libstdc++: std::future< _Res > Class Template Reference

libstdc++

std::future< _Res > Class Template Reference
Concurrency » Futures

`#include <future>`

Inheritance diagram for std::future< _Res >:
[legend]

## Public Member Functions
| future (const future &)=delete
| future (future &&__uf) noexcept
_Res | get ()
future & | operator= (const future &)=delete
future & | operator= (future &&__fut) noexcept
shared_future< _Res > | share () noexcept
bool | valid () const noexcept
void | wait () const
template<typename _Rep, typename _Period>
future_status | wait_for (const chrono::duration< _Rep, _Period > &__rel) const
template<typename _Clock, typename _Duration>
future_status | wait_until (const chrono::time_point< _Clock, _Duration > &__abs) const

## Protected Types
typedef __future_base::_Result< _Res > & | __result_type

## Protected Member Functions
__result_type | _M_get_result () const
void | _M_swap (__basic_future &__that) noexcept

## Friends
template<typename _Fn, typename... _Args>
future< __async_result_of< _Fn, _Args... > > | async (launch, _Fn &&, _Args &&...)
template<typename>
class | packaged_task
class | promise< _Res >

## Detailed Description

template<typename _Res>
class std::future< _Res >

Primary template for future.

Definition at line 795 of file future.

## Member Typedef Documentation

## ◆ __result_type

template<typename _Res>

typedef __future_base::_Result<_Res>& std::__basic_future< _Res >::__result_type
| protectedinherited

Definition at line 709 of file future.

## Constructor & Destructor Documentation

## ◆ future() [1/2]

template<typename _Res>

std::future< _Res >::future | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 817 of file future.

## ◆ future() [2/2]

template<typename _Res>

std::future< _Res >::future | ( | future< _Res > && | __uf | ) |
| inlinenoexcept

Move constructor.

Definition at line 820 of file future.

References std::move().

## Member Function Documentation

## ◆ _M_get_result()

template<typename _Res>

__result_type std::__basic_future< _Res >::_M_get_result | ( |  | ) | const
| inlineprotectedinherited

Wait for the state to be ready and rethrow any stored exception.

Definition at line 748 of file future.

Referenced by std::future< _Res >::get(), and std::shared_future< _Res >::get().

## ◆ _M_swap()

template<typename _Res>

void std::__basic_future< _Res >::_M_swap | ( | __basic_future< _Res > & | __that | ) |
| inlineprotectednoexceptinherited

Definition at line 757 of file future.

## ◆ get()

template<typename _Res>

_Res std::future< _Res >::get | ( |  | ) |
| inline

Retrieving the value.

Definition at line 834 of file future.

References std::__basic_future< _Res >::_M_get_result(), and std::move().

## ◆ operator=()

template<typename _Res>

future & std::future< _Res >::operator= | ( | future< _Res > && | __fut | ) |
| inlinenoexcept

Definition at line 826 of file future.

## ◆ valid()

template<typename _Res>

bool std::__basic_future< _Res >::valid | ( |  | ) | const
| inlinenoexceptinherited

Definition at line 720 of file future.

## ◆ wait()

template<typename _Res>

void std::__basic_future< _Res >::wait | ( |  | ) | const
| inlineinherited

Definition at line 723 of file future.

## ◆ wait_for()

template<typename _Res>
template<typename _Rep, typename _Period>

future_status std::__basic_future< _Res >::wait_for | ( | const chrono::duration< _Rep, _Period > & | __rel | ) | const
| inlineinherited

Definition at line 731 of file future.

## ◆ wait_until()

template<typename _Res>
template<typename _Clock, typename _Duration>

future_status std::__basic_future< _Res >::wait_until | ( | const chrono::time_point< _Clock, _Duration > & | __abs | ) | const
| inlineinherited

Definition at line 739 of file future.

## Friends And Related Symbol Documentation

## ◆ packaged_task

template<typename _Res>
template<typename>

friend class packaged_task
| friend

Definition at line 805 of file future.

## ◆ promise< _Res >

template<typename _Res>

friend class promise< _Res >
| friend

Definition at line 801 of file future.

The documentation for this class was generated from the following file:

- future